﻿B4J=true
Group=Classes\Handlers
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
' Base Handler class
' Version 0.18
Sub Class_Globals
	
End Sub

Public Sub Initialize
	
End Sub

Sub Handle (req As ServletRequest, resp As ServletResponse)
	If Main.PRINT_FULL_REQUEST_URL Then
		Log($"${req.Method}: ${req.FullRequestURI}"$)
	End If
	If EMCore.isApiRequest(req, Main.BaseElements) Then
		ProcessApiRequest(req, resp)
		Return
	End If
	If EMCore.isWebRequest(req, Main.BaseElements) Then
		ProcessWebRequest(req, resp)
		Return
	End If
	EMCore.ReturnHtmlPageNotFound(resp)
End Sub

Sub ProcessWebRequest (Request As ServletRequest, Response As ServletResponse)
	Dim UriElements As Map = EMCore.RequestElements(Request, Main.BaseElements)
	If UriElements.Size - 1 = Main.BaseElements.Path.Index Then
		If UriElements.Get("Path") <> Main.BaseElements.Path.Element Then
			EMCore.ReturnHtmlPageNotFound(Response)
			Return
		End If
		Dim Index As IndexController
		Index.Initialize(Request, Response)
		Index.RouteWeb
		Return
	End If
	Dim Controller As String = UriElements.GetDefault("Controller", "")
	Select Controller
		Case "hello"
			Dim Hello As HelloController
			Hello.Initialize(Request, Response)
			Hello.RouteWeb
			Return
	End Select
	
	LogColor("Unknown url: " & Request.FullRequestURI, Main.COLOR_RED)
	If Request.Method.ToUpperCase = "GET" Then
		EMCore.ReturnHtmlPageNotFound(Response)
	Else
		EMCore.ReturnMethodNotAllow(Response)
	End If
End Sub

Sub ProcessApiRequest (Request As ServletRequest, Response As ServletResponse) 'ignore
	Dim UriElements As Map = EMCore.RequestElements(Request, Main.BaseElements)
	Dim Controller As String = UriElements.GetDefault("Controller", "")
	Select Controller
		Case "hello"
			Dim Hello As HelloController
			Hello.Initialize(Request, Response)
			Hello.RouteApi
			Return
	End Select
	
	LogColor("Unknown url: " & Request.FullRequestURI, Main.COLOR_RED)
	If Request.Method.ToUpperCase = "GET" Then
		EMCore.ReturnBadRequest(Response)
	Else
		EMCore.ReturnMethodNotAllow(Response)
	End If
End Sub